%% hairplots.m generates a .mat file with smoothed states and "hair"
%% forecasts for plotting
function [saved] = hairplots_rwNODRIFTfullSample(mspec,sm_states,Startdate,T,TTT,NN_)
mc_t = getState(mspec,0,'mc_t');                                    % Get Marginal cost state
hair = nan(size(sm_states,2)-Startdate+2,size(sm_states,2)+NN_);    % initialize data matrix for hairplots
hair(1,1:size(sm_states,2)) = sm_states(mc_t,:);                    % store smoothed state of mc in first row


drift = ( sm_states(mc_t,end) - sm_states(mc_t,Startdate) ) / ( size(sm_states,2) - Startdate );

for j = T:size(sm_states,2)       % loop over "root" dates for hairs
    x0 = sm_states(mc_t,j);   % set root value (all states)
    k = j-Startdate+2;        % set root index
    hair(k,j)=x0;             % select mc root value
    
    % grow hairs
    hair(k,j+1:j+NN_)= x0;
end

save(['hairplots_mc_rwNODRIFTfullSample',num2str(mspec),'.mat'],'hair');
saved = 1;
end
        
        
        
        