function [pitilde_all] = fnGenPiTil(ti,Y1,Y2,kSt,para,mspec)

if mspec == 904
    [alp,zeta_p,iota_p,del,ups,Bigphi,s2,h,ppsi,nu_l,zeta_w,iota_w,law,laf,bet,Rstarn,psi1,psi2,psi3,pistar,sigmac,rho,epsp,epsw...
        gam,Lmean,Lstar,gstar,rho_g,rho_b,rho_mu,rho_z,rho_laf,rho_law,rho_rm,rho_sigw,rho_mue,rho_gamm,rho_pist...
        sig_g,sig_b,sig_mu,sig_z,sig_laf,sig_law,sig_rm,sig_sigw,sig_mue,sig_gamm,sig_pist,eta_gz,eta_laf,eta_law...
        zstar,rstar,rkstar,wstar,wl_c,cstar,kstar,kbarstar,istar,ystar,sprd,zeta_spb,gammstar,vstar,nstar,...
        zeta_nRk,zeta_nR,zeta_nsigw,zeta_spsigw,zeta_nmue,zeta_spmue,zeta_nqk,zeta_nn] = getpara00_904(para);
elseif mspec == 805
    [alp,zeta_p,iota_p,del,ups,Bigphi,s2,h,ppsi,nu_l,zeta_w,iota_w,law,laf,bet,Rstarn,psi1,psi2,psi3,pistar,sigmac,rho,epsp,epsw...
        gam,Lmean,Lstar,gstar,rho_g,rho_b,rho_mu,rho_z,rho_laf,rho_law,rho_rm,rho_pist...
        sig_g,sig_b,sig_mu,sig_z,sig_laf,sig_law,sig_rm,sig_pist,eta_gz,eta_laf,eta_law...
        zstar,rstar,rkstar,wstar,wl_c,cstar,kstar,kbarstar,istar,ystar,pistflag] = getpara00_805(para);
elseif mspec == 803
    [alp,zeta_p,iota_p,del,ups,Bigphi,s2,h,ppsi,nu_l,zeta_w,iota_w,law,laf,bet,Rstarn,psi1,psi2,psi3,pistar,sigmac,rho,epsp,epsw...
        gam,Lmean,Lstar,gstar,rho_g,rho_b,rho_mu,rho_z,rho_laf,rho_law,rho_rm,...
        sig_g,sig_b,sig_mu,sig_z,sig_laf,sig_law,sig_rm,eta_gz,eta_laf,eta_law...
        zstar,rstar,rkstar,wstar,wl_c,cstar,kstar,kbarstar,istar,ystar] = getpara00_803(para);
else
    error(['fnGenPiTil.m doesn''t support model ',num2str(mspec)]);
end

pitilde = nan(size(Y1,1),1);
for i = 4:size(pitilde,1)
    pitilde(i) = Y1(i,kSt) + iota_p*Y1(i-1,kSt) ...
        + iota_p^2*Y1(i-2,kSt) + iota_p^3*Y1(i-3,kSt);
end

pitilde_ctr = nan(size(Y2,1),1);
for i = 4:size(pitilde_ctr,1)
    pitilde_ctr(i) = Y2(i,kSt) + iota_p*Y2(i-1,kSt) ...
        + iota_p^2*Y2(i-2,kSt) + iota_p^3*Y2(i-3,kSt);
end

pitilde_all = [ pitilde/4 + 100*(pistar-1), pitilde_ctr/4 + 100*(pistar-1)];
